/*  Project partsasm
	Project Team DoGA
	Copyright (c) 1995. All Rights Reserved.

	TuVXe:    partsasm.apx Application
	t@C:        status.cpp
	쐬:          Taka2


	Tv
	====
	TWinStatus (TWindow) ̃Cve[Vp̃\[Xt@C
*/

#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\statusba.h>
#include <owl\button.h>
#include <owl\edit.h>
#include "status.h"
#include "matrix.h"
#include "design.h"
#include "parts.h"
#include "suflib.h"
#include "syscolor.h"
#include "dinput.h"

#include "log.h"

#define ws (textwidth / 2)
#define hs (textheight-1)
#define ss 1 //(textheight / 4)


//
// ̃AvP[Vŏ邷ׂẴbZ[W^R}h
// e[u쐬
//
DEFINE_RESPONSE_TABLE1(TWinStatus, TWindow)
//{{TWinStatusRSP_TBL_BEGIN}}
    EV_WM_LBUTTONDOWN,
//{{TWinStatusRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{TWinStatus Implementation}}


TWinStatus::TWinStatus (TWindow* parent, DesignData *dat, int x, int y, int w, int h):
	TWindow(parent, 0, 0)
{
	SetBkgndColor(TColor::LtGray);

	designdata = dat;
	nowstatus = STAT_NONE;
	Attr.X = x;
	Attr.Y = y;
	Attr.W = w;
	Attr.H = h;
}


TWinStatus::~TWinStatus ()
{
	Destroy();

	// INSERT>> fXgN^p̃R[h͂

}



void TWinStatus::VectorOutInt(TDC& dc, int x, int y, Vector &v)
{
	char str[16];
	sprintf(str, "%5.0lf     ", v.x); 	dc.TextOut(x, y       , str);
	sprintf(str, "%5.0lf     ", v.y); 	dc.TextOut(x, y + hs  , str);
	sprintf(str, "%5.0lf     ", v.z); 	dc.TextOut(x, y + hs*2, str);
}

void TWinStatus::VectorOutFloat(TDC& dc, int x, int y, Vector &v)
{
	char str[16];
	sprintf(str, "%5.2lf     ", v.x); 	dc.TextOut(x, y       , str);
	sprintf(str, "%5.2lf     ", v.y); 	dc.TextOut(x, y + hs  , str);
	sprintf(str, "%5.2lf     ", v.z); 	dc.TextOut(x, y + hs*2, str);
}

void TWinStatus::DisplayPosition(Vector& v)
{
	TClientDC dc(*this);
	dc.SetBkColor(TColor(cTextBG));
	VectorOutInt(dc, textwidth*3, hs* 3+ss*2, v);

}

void TWinStatus::DisplayTarget(Vector& v)
{
	TClientDC dc(*this);
	dc.SetBkColor(TColor(cTextBG));
	VectorOutInt(dc, textwidth*3, hs* 7+ss*3, v);
}

void TWinStatus::DisplayRotation(Vector& v)
{
	TClientDC dc(*this);
	dc.SetBkColor(TColor(cTextBG));
	VectorOutInt(dc, textwidth*3, hs* 7+ss*3, rad(1) * v);
}

void TWinStatus::DisplayScale(Vector& v)
{
	TClientDC dc(*this);
	dc.SetBkColor(TColor(cTextBG));
	VectorOutFloat(dc, textwidth*3, hs*11+ss*4, v);
}

void TWinStatus::Redraw(void)
{
	if (UpdateStatus() == FALSE) {
		DisplayStatus(FALSE);
	}
}

void TWinStatus::DisplayStatusObject(TDC& dc, int flag, Parts *p)
{
	if (flag == TRUE) {
//		dc.SelectStockObject(WHITE_PEN);
		dc.Rectangle(dc.GetClipBox());
//		dc.TextOut(ws,       ss  , "p[c:");
		dc.TextOut(ws, hs* 2+ss*2, "ʒu");
		dc.TextOut(ws, hs* 3+ss*2, "X:");
		dc.TextOut(ws, hs* 4+ss*2, "Y:");
		dc.TextOut(ws, hs* 5+ss*2, "Z:");
		dc.TextOut(ws, hs* 6+ss*3, "]");
		dc.TextOut(ws, hs* 7+ss*3, "X:");
		dc.TextOut(ws, hs* 8+ss*3, "Y:");
		dc.TextOut(ws, hs* 9+ss*3, "Z:");
		dc.TextOut(ws, hs*10+ss*4, "g");
		dc.TextOut(ws, hs*11+ss*4, "X:");
		dc.TextOut(ws, hs*12+ss*4, "Y:");
		dc.TextOut(ws, hs*13+ss*4, "Z:");
	}
	char str[120];
	if (p == designdata->combined) {
		sprintf(str, "I(%d)      ", designdata->combined->nparts);
	} else {
		sprintf(str, "%s    ", p->object->name);
	}
	dc.TextOut(ws, ss, str);
	sprintf(str, "%3d      ", p->polygons);
	dc.TextOut(ws+textwidth, hs+ss, str);
	VectorOutInt  (dc, textwidth*3, hs* 3+ss*2, p->position);
	VectorOutInt  (dc, textwidth*3, hs* 7+ss*3, rad(1) * p->rotation);
	VectorOutFloat(dc, textwidth*3, hs*11+ss*4, p->scale);
}

void TWinStatus::DisplayStatusCamera(TDC& dc, int flag, CameraParts *p)
{
	if (flag == TRUE) {
//		dc.SelectStockObject(WHITE_PEN);
		dc.Rectangle(dc.GetClipBox());
		dc.TextOut(ws,      ss  , "J");
		dc.TextOut(ws, hs*2+ss*2, "Jʒu");
		dc.TextOut(ws, hs*3+ss*2, "X:");
		dc.TextOut(ws, hs*4+ss*2, "Y:");
		dc.TextOut(ws, hs*5+ss*2, "Z:");
		dc.TextOut(ws, hs*6+ss*3, "ޯĈʒu");
		dc.TextOut(ws, hs*7+ss*3, "X:");
		dc.TextOut(ws, hs*8+ss*3, "Y:");
		dc.TextOut(ws, hs*9+ss*3, "Z:");
	}
	VectorOutInt(dc, textwidth*3, hs* 3+ss*2, p->position);
	VectorOutInt(dc, textwidth*3, hs* 7+ss*3, p->target);

}

void TWinStatus::DisplayStatus(int flag)
{
	TClientDC dc(*this);
	dc.SetBkColor(TColor(cTextBG));
	dc.SelectObject(TPen(cTextBG));
	dc.SelectObject(TBrush(cTextBG));
	if (nowstatus == STAT_OBJ) {
		DisplayStatusObject(dc, flag, designdata->select);
		if (designdata->gridflag) {
			designdata->statusbar->SetText(":ړ :] :g CTRL:Obh SHIFT:sړ SHIFT:g E:m");
		} else {
			designdata->statusbar->SetText(":ړ :] :g CTRL:ObhL SHIFT:sړ SHIFT:g E:m");
		}
	} else if (nowstatus == STAT_CAMERA) {
		DisplayStatusCamera(dc, flag, designdata->camera);
		designdata->statusbar->SetText("ԃ}[N𓮂AJʒuA^[QbgʒuύXĂ");
	} else {
		if (flag == TRUE) {
			dc.Rectangle(dc.GetClipBox());
		}
		if (designdata->zoommode == ZoomSelect) {
			designdata->statusbar->SetText("Y[ʒuNbNĂ");
		} else if (designdata->parts != NULL) {
			designdata->statusbar->SetText("Ƀp[cǉ邩Aԃ}[NNbNăp[cIĂ");
		} else {
			designdata->statusbar->SetText("[p[c]/[p[cǉ] Ńp[cǉĂ");
		}

	}
}

void TWinStatus::DisplayStatusTemp(Parts *p)
{
	TClientDC dc(*this);
	dc.SelectObject(TPen(cTextBG));
	dc.SelectObject(TBrush(cTextBG));
	dc.SetBkColor(TColor(cTextBG));
	if (nowdisplay != p) {
		nowdisplay = p;
		if (p == NULL) {
			dc.SelectStockObject(WHITE_PEN);
			dc.Rectangle(dc.GetClipBox());
		} else if (p == designdata->camera) {
			DisplayStatusCamera(dc, TRUE, designdata->camera);
		} else {
			DisplayStatusObject(dc, TRUE, p);
		}
	}
}

int TWinStatus::UpdateStatus(void)
{
	StatusMode nstat;
	if (designdata->select == NULL) {
		nstat = STAT_NONE;
		nowdisplay = NULL;
	} else if (designdata->select == designdata->camera) {
		nstat = STAT_CAMERA;
		nowdisplay = designdata->camera;
	} else {
		nstat = STAT_OBJ;
		nowdisplay = designdata->select;
	}
	if (designdata->zoommode == ZoomNow) {
		designdata->button_zoom->Show(SW_SHOW);
	} else {
		designdata->button_zoom->Show(SW_HIDE);
	}
	if (nstat == STAT_NONE || designdata->zoommode == ZoomSelect) {
		designdata->button_ok->Show(SW_HIDE);
		designdata->button_cancel->Show(SW_HIDE);
	} else {
		designdata->button_ok->Show(SW_SHOW);
		designdata->button_cancel->Show(SW_SHOW);
	}

	if (nstat != nowstatus) {
		nowstatus = nstat;
		DisplayStatus(TRUE);
		return TRUE;
	}
	return FALSE;
}


void TWinStatus::Paint (TDC& dc, BOOL erase, TRect& rect)
{
	TWindow::Paint(dc, erase, rect);

	// INSERT>> ǉ̃R[h͂

	DisplayStatus(TRUE);
}



void TWinStatus::SetupWindow ()
{
	TWindow::SetupWindow();

	// INSERT>> ǉ̃R[h͂
	TClientDC dc(*this);
	TEXTMETRIC metric;
	dc.GetTextMetrics(metric);
	textheight = metric.tmHeight;
	textwidth = metric.tmAveCharWidth;

}

void TWinStatus::EvLButtonDown (UINT modKeys, TPoint& point)
{
	TWindow::EvLButtonDown(modKeys, point);

	// INSERT>> ǉR[h͂

	if (designdata->select != NULL) {
		TDDirectInput dialog(this, designdata, 0);
		if (dialog.Execute() == IDOK) {
			if (designdata->select != designdata->camera) designdata->editflag++;
			if (designdata->select == designdata->camera) {
				designdata->camera->SetTarget(designdata->camera->target);
				designdata->Redraw(SelAll, TRUE);
			} else {
				designdata->CalcPoints(designdata->select);
				designdata->Redraw();
			}
		}
	}
}

